/' small propgram to automate dumping dissassebly from elf file 
<ARDUINOPATH>/hardware/tools/avr/bin/avr-objdump -d 
   <BUILDPATH>/<PROJECTNAME>.cpp.elf > <PROJECTNAME>.asm
 
Source code is placed in public domain: August 2013, Lewis Balentine, lewis@keywild.com
Target compiler: FreeBasic, http://www.freebasic.net/
Note: This is written to run as a console application under Windows.
      I suspect numerous changes would be needed for linux.  
'/
' ----------------------------------------------------------------------------------------
# Include "dir.bi"
dim HomePath as string          '' users HOMEDRIVE and HOMEPATH
dim AppDataPath as string       '' users HOMEDRIVE and APPDATA
dim PrefFile as string          '' users's Arduino preferencesfile
Dim SketchPath as String        '' users's Arduino Sketchbook 
Dim BuildPath as String         '' Arduino build directory  
Dim ElfFile as String           '' Elf file name (with path) 
Dim ProjName as String          '' Arduino project name
Dim AvrObjDump as String        '' Avr-ObjDump.exe with full path
Dim AvrReadElf as String        '' Avr-readelf.exe with full path
Dim CmdFile as String           '' CMD file with full path 
Dim Cr as String                '' Carriage return/line feed (ASCII 13,10)
Dim HelpStr as String           '' command line Help  
Dim DmpOpts as String           '' Options for Avr-ObjDump.exe
Dim ElfOpts as String           '' Options for Avr-readelf.exe

Dim Buffer as String            '' working buffer for reading files
Dim TempStr as String           '' working string  

Dim P as Integer                '' position from instr
' ----------------------------------------------------------------------------------------
Cr=chr(13) & chr(10)
' ----------------------------------------------------------------------------------------
HelpStr= "Arduino-elf-dump.exe is a small program written in FreeBasic to automate the" & Cr & _
         "process of creating dume files from the elf file produced by the Ardunio IDE." & Cr & _
         "The program attempts to write a CMD file to the project directory and execute" & Cr & _
         "it. The CMD file allows the Avr-ObjDump and/or Avr-readelf options to be" & Cr & _
         "edited as desired. The dump files are also placed in the project directory. " & Cr & _
         Cr & _
         "This program requires that 'build.path' be specified in the user's Ardunio" & Cr & _
         "preferences file. Please set up a directory for builds and add it to your " & Cr & _
         "preferences file.Please also set preproc.save_build_files to true." & Cr & _
         Cr & _
         "The program searches the following directories for Avr-ObjDump & Avr-readelf:" & Cr & _
         "    C:\Program Files (x86)\Arduino\hardware\tools\avr\bin\"  & Cr & _
         "    C:\Program Files\Arduino\hardware\tools\avr\bin\"  & Cr & _
         "    C:\Arduino\hardware\tools\avr\bin\"  & Cr & _
         "    C:\bin\Arduino\hardware\tools\avr\bin\"  & Cr & _
         Cr & _
         "The program searches the following directories for project directory:" & Cr & _
         "    Sketchbook (as defined in Arduino preferences file)" & Cr & _
         "    <users home path>\Documents\Arduino" & Cr & _
         "    <users home path>\My Documents\Arduino" & Cr & _
         "    <users home path>\Documents\Projects" & Cr & _
         "    <users home path>\My Documents\Projects" & Cr & _
         "If project directory can be found then the CMD file is written to the build" & Cr & _
         "is written to the build directory." & Cr & _
         Cr & _
         "There are no command line options." & Cr & _
         "This program is Public Domain open source." & Cr
' ----------------------------------------------------------------------------------------
DmpOpts= Cr & Cr & "exit" & Cr  & Cr & _
         "avr-objdump" & Cr & _
         "Options are:" & Cr & _
         "  -a, --archive-headers    Display archive header information" & Cr & _
         "  -f, --file-headers       Display the contents of the overall file header" & Cr & _
         "  -p, --private-headers    Display object format specific file header contents" & Cr & _
         "  -h, --[section-]headers  Display the contents of the section headers" & Cr & _
         "  -x, --all-headers        Display the contents of all headers" & Cr & _
         "  -d, --disassemble        Display assembler contents of executable sections" & Cr & _
         "  -D, --disassemble-all    Display assembler contents of all sections" & Cr & _
         "  -S, --source             Intermix source code with disassembly" & Cr & _
         "  -s, --full-contents      Display the full contents of all sections requested" & Cr & _
         "  -g, --debugging          Display debug information in object file" & Cr & _
         "  -e, --debugging-tags     Display debug information using ctags style" & Cr & _
         "  -G, --stabs              Display (in raw form) any STABS info in the file" & Cr & _
         "  -W, --dwarf              Display DWARF info in the file" & Cr & _
         "  -t, --syms               Display the contents of the symbol table(s)" & Cr & _
         "  -T, --dynamic-syms       Display the contents of the dynamic symbol table" & Cr & _
         "  -r, --reloc              Display the relocation entries in the file" & Cr & _
         "  -R, --dynamic-reloc      Display the dynamic relocation entries in the file" & Cr & Cr
' ----------------------------------------------------------------------------------------
ElfOpts= Cr & _
        "readelf" & Cr & _
        "Options are:" & Cr & _
        "  -a --all               Equivalent to: -h -l -S -s -r -d -V -A -I" & Cr & _
        "  -h --file-header       Display the ELF file header" & Cr & _
        "  -l --program-headers   Display the program headers" & Cr & _
        "  -S --section-headers   Display the sections' header" & Cr & _
        "  -g --section-groups    Display the section groups" & Cr & _
        "  -t --section-details   Display the section details" & Cr & _
        "  -e --headers           Equivalent to: -h -l -S" & Cr & _
        "  -s --symbols           Display the symbol table" & Cr & _
        "  -n --notes             Display the core notes (if present)" & Cr & _
        "  -r --relocs            Display the relocations (if present)" & Cr & _
        "  -u --unwind            Display the unwind info (if present)" & Cr & _
        "  -d --dynamic           Display the dynamic section (if present)" & Cr & _
        "  -V --version-info      Display the version sections (if present)" & Cr & _
        "  -A --arch-specific     Display architecture specific information (if any)." & Cr & _
        "  -c --archive-index     Display the symbol/file index in an archive" & Cr & _
        "  -D --use-dynamic       Use the dynamic section info when displaying symbols" & Cr 
' ----------------------------------------------------------------------------------------
 
' check for command line arguments
TempStr = Command (-1)
If TempStr <> "" then
    Print HelpStr
    End 0
End if
    
  
' Get users HOMEDRIVE and HOMEPATH from enviroment 
HomePath = Environ("HomeDrive") & Environ("HomePath") & "\"
' Print HomePath

' Get users HOMEDRIVE and APPDATA from enviroment 
AppDataPath =  Environ("AppData") & "\"
' Print AppDataPath

' Find Arduino preferences file
' <AppData>\Arduino\preferences.txt
PrefFile=AppDataPath & "\Arduino\preferences.txt"
If Dir(PrefFile) = "" then
    Print "**ERROR** Can not find Ardunio preferences file:" 
    Print PrefFile
    Sleep   ' sleep waits for a keypress before continueing
    End -1
End If

'Open file and look for build.path & sketchbook.path
' build.path=<users path>\Documents\Arduino\Build
' sketchbook.path=<users path>\Documents\Arduino
' preproc.save_build_files=true
Open PrefFile for input as #1
If Err>0 Then 
    Print "**Error** opening Ardunio preferences file:" 
    Print PrefFile
    sleep
    End -1
End If

BuildPath=""
SketchPath=""
Do Until EOF(1)                 '' loop until we have reached the end of the file
   Line Input #1, buffer        '' read a line of text
   buffer=Lcase(Trim(buffer))   '' we should not need this but ...
   If InStr (buffer, "build.path")=1 then BuildPath=buffer
   If InStr (buffer, "sketchbook.path")=1 then SketchPath=buffer
Loop
Close #1

' for this to work we reuire that a build path be set in the Ardunio preferences file
If Len(BuildPath) < 20 then
    Print "**ERROR** This program requires that the 'build.path' is specified"
    Print "          in the user's Ardunio preferences file. Please set up a"
    Print "          directory for builds and add it to your preferences file."
    Print "  Example:"
    Print "          build.path=" & HomePath & "Documents\Arduino\Build" 
    Print ""
    Print "          Please also set preproc.save_build_files to true."
    Print ""
    Print "Your Ardunio preferences file is:"
    Print PrefFile
    Sleep
    End -1
End If

' Now go find the the build
' First we need to strip off "build.path="
P=InStr (BuildPath, "=")
BuildPath = Trim(Mid (BuildPath, P+1)) & "\"
ElfFile =""
ElfFile = Dir (BuildPath & "*.elf")
If ElfFile ="" then
    Print "**ERROR** Can not find '*.elf' file in build directory:"
    Print BuildPath
    Sleep
    End -1
End If

' Extract project name ... example: HelloWorld_001.cpp.elf
' this should be everything in front of .cpp.elf
P=InStr (ElfFile, ".cpp.elf")
ProjName=Trim(Left (ElfFile,P-1))
' Now see if we can find the project directory
if SketchPath<>"" then
    P=InStr (SketchPath, "=")
    ' SketchPath = Trim(Mid (SketchPath, P+1)) & "\sketches\" & ProjName
    TempStr = Trim(Mid (SketchPath, P+1)) & "\sketches\" & ProjName & "\"
end if
if  dir(TempStr  & ProjName & ".ino")="" then
    ' try an alternative
    TempStr = Trim(Mid (SketchPath, P+1)) & "\" & ProjName &"\"
end if
if  dir(TempStr  & ProjName & ".ino")="" then
    ' try an alternative
    TempStr = HomePath & "Documents\Projects\" & ProjName &"\"
end if
if  dir(TempStr  & ProjName & ".ino")="" then
    ' try an alternative
    TempStr = HomePath & "My Documents\Projects\" & ProjName &"\"
end if
if  dir(TempStr  & ProjName & ".ino")="" then
    ' try an alternative
    TempStr = HomePath & "Documents\Arduino\" & ProjName &"\"
end if
if  dir(TempStr  & ProjName & ".ino")="" then
    ' try an alternative
    TempStr = HomePath & "My Documents\Arduino\" & ProjName &"\"
end if


If  dir(TempStr  & ProjName & ".ino")="" then
    ' instead of an error we are going to dump the assembly output to
    ' the build directory
    SketchPath=BuildPath
else
    SketchPath=TempStr
end If

' now find the avr-objdump
' <ARDUINOPATH>/hardware/tools/avr/bin/avr-objdump
' C:\Program Files (x86)\Arduino\hardware\tools\avr\bin
AvrObjDump=""
TempStr = "C:\Program Files (x86)\Arduino\hardware\tools\avr\bin\avr-objdump.exe"
If Dir(TempStr)<>"" then AvrObjDump=TempStr
TempStr = "C:\Program Files\Arduino\hardware\tools\avr\bin\avr-objdump.exe"
If Dir(TempStr)<>"" then AvrObjDump=TempStr
TempStr = "C:\Arduino\hardware\tools\avr\bin\avr-objdump.exe"
If Dir(TempStr)<>"" then AvrObjDump=TempStr
TempStr = "C:\bin\Arduino\hardware\tools\avr\bin\avr-objdump.exe"
If Dir(TempStr)<>"" then AvrObjDump=TempStr
If AvrObjDump ="" then
    Print "**ERROR** Can not find 'avr-objdump.exe'."
    Print "Searched:"
    Print "    C:\Program Files (x86)\Arduino\hardware\tools\avr\bin\"
    Print "    C:\Program Files\Arduino\hardware\tools\avr\bin\"
    Print "    C:\Arduino\hardware\tools\avr\bin\"
    Print "    C:\bin\Arduino\hardware\tools\avr\bin\"
    Sleep
    End -1
End If
P=Instr(AvrObjDump,"avr-objdump.exe")
AvrReadElf=Left(AvrObjDump,P-1) & "avr-readelf.exe"

' Now build our command string ...
CmdFile = SketchPath & ProjName & "_dump.cmd"
open CmdFile for output as #1
TempStr = chr(34) & AvrObjDump & chr(34) & " -S " 
TempStr = TempStr & chr(34) & BuildPath & ElfFile & chr(34) 
TempStr = TempStr & " > " & chr(34) & SketchPath & ProjName & ".asm.txt" & chr(34)
Print #1, TempStr
TempStr = chr(34) & AvrReadElf & chr(34) & " -e " 
TempStr = TempStr & chr(34) & BuildPath & ElfFile & chr(34) 
TempStr = TempStr & " > " & chr(34) & SketchPath & ProjName & ".hrd.txt" & chr(34)
Print #1, TempStr
Print #1, DmpOpts
Print #1, ElfOpts
Close #1
Shell CmdFile 
end 0